Unit SF48R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF12_p, SF51R_p, SF47R_p;

function SF48R(P :Real; AN :Real; var IERR :Integer): Real;

implementation

function SF48R(P :Real; AN :Real; var IERR :Integer): Real;
var
IERR1 :Integer;
X,XL,XR,FT,P1,FXL,FXR :Real;
const
R :Real = 0.2222222E0;
SYS059 :Real = 3.4E38;
ZERO :Real = 0.0E0;
SYS089 :Real = 1.0E-6;
AMIN :Real = 0.5E0;
DX :Real = 1.0E0;
ANMAX :Real = 40.0E0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
{ Result -    SF48R  FORTRANe }
IERR := 0;
if ( (P > 0.E0) ) and ( (P < 1.E0) ) 
 then goto _1;
IERR := 65;
goto _9;
_1:
if ( AN >= AMIN ) 
 then goto _2;
IERR := 66;
goto _9;
_2:
if ( AN < ANMAX ) 
 then goto _3;
XR := SF51R(P,IERR1);
X := R/AN;
Result := AN*IntPower((1.E0-X+XR*Sqrt(X)),3);
goto _10;
_3:
X := 0.E0;
_4:
P1 := SF47R(X,AN,IERR1);
if ( P1 >= P ) 
 then goto _5;
XL := X;
X := X+DX;
FXL := P1-P;
goto _4;
_5:
XR := X;
FXR := P1-P;
_6:
X := (XL+XR)*0.5;
P1 := SF47R(X,AN,IERR1);
FT := P1-P;
Result := X;
if ( FT*FXL > ZERO ) 
 then goto _7;
XR := X;
FXR := FT;
goto _8;
_7:
XL := X;
FXL := FT;
_8:
if ( Abs(FT) <= SYS089 ) 
 then goto _10;
if ( (XR-XL) <= SYS089*Abs(X) ) 
 then goto _10;
goto _6;
_9:
UTSF12(IERR,48);
Result := SYS059;
_10:
exit;
end;

end.
